using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Runtime.Remoting.Messaging;
using System.Threading;

using Microsoft.DirectX;
using Microsoft.DirectX.Diagnostics;

namespace DiagInfo
{
	/// <summary>
	/// Form1 ̊Tv̐łB
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TreeView treeView1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Timer timer1;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			_thread = new Thread( new ThreadStart( this.LoadDiagInformation ) );
			_thread.Name = "WXbh";
			_thread.IsBackground = true;
			_thread.Start();

			this.timer1.Start();
		}

		Thread _thread = null;
		private delegate void UpdateInfoDelegate( TreeNode[] nodes );

		private void LoadDiagInformation()
		{
			// MDX ̗ɂ COM IuWFNg DxDiagProvider ̐ŁC
			// Container NX STA łȂΏłȂD
			// ̂߃Xbhv[p񓯊\bhĂяo
			// ̏uɂ͏\ȒKvł
			System.Threading.Thread.CurrentThread.ApartmentState = ApartmentState.STA;
			Microsoft.DirectX.Diagnostics.Container container = new Microsoft.DirectX.Diagnostics.Container(false);

			TreeNode rootNode = new TreeNode();
			AddContainer(rootNode, container);
			TreeNode[] nodes = new TreeNode[ rootNode.Nodes.Count ];
			rootNode.Nodes.CopyTo( nodes, 0 );
			this.Invoke( new UpdateInfoDelegate( this.UpdateInfo ), new object[]{ nodes } );
		}

		private void AddContainer( TreeNode node, Microsoft.DirectX.Diagnostics.Container container )
		{
			foreach( Microsoft.DirectX.Diagnostics.ContainerData containerData in container.Containers )
			{
				TreeNode containerNode = new TreeNode( "[" + containerData.Name + "]");
				AddContainer( containerNode, containerData.Container );
				node.Nodes.Add( containerNode );
			}
			foreach( Microsoft.DirectX.Diagnostics.PropertyData propData in container.Properties )
			{
				TreeNode propNode = new TreeNode( propData.Name );
				propNode.Nodes.Add( new TreeNode( propData.Data.ToString() ) );
				node.Nodes.Add( propNode );
			}

		}

		[OneWayAttribute]
		private void UpdateInfo( TreeNode[] nodes )
		{
			this.SuspendLayout();
			this.timer1.Stop();
			this.label1.Visible = false;
			this.treeView1.BackColor = this.BackColor;
			this.treeView1.Nodes.AddRange( nodes );
			this.ResumeLayout(true);
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.treeView1 = new System.Windows.Forms.TreeView();
			this.label1 = new System.Windows.Forms.Label();
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.SuspendLayout();
			// 
			// treeView1
			// 
			this.treeView1.BackColor = System.Drawing.SystemColors.Window;
			this.treeView1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.treeView1.ImageIndex = -1;
			this.treeView1.Name = "treeView1";
			this.treeView1.SelectedImageIndex = -1;
			this.treeView1.Size = new System.Drawing.Size(292, 266);
			this.treeView1.TabIndex = 0;
			// 
			// label1
			// 
			this.label1.BackColor = System.Drawing.SystemColors.ControlDark;
			this.label1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.label1.Font = new System.Drawing.Font("Verdana", 14.25F, (System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.Color.Black;
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(292, 266);
			this.label1.TabIndex = 1;
			this.label1.Text = "Now Loading";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// timer1
			// 
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.BackColor = System.Drawing.SystemColors.Window;
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.treeView1});
			this.Name = "Form1";
			this.Text = "DirectX Diagnostics Information";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		static void Main() 
		{
			System.Threading.Thread.CurrentThread.ApartmentState = ApartmentState.STA;
			Application.Run(new Form1());
		}

		private void timer1_Tick(object sender, System.EventArgs e)
		{
			int interval = 2000;
			double theta = Math.PI * 2.0 * Environment.TickCount / interval;
			this.label1.ForeColor = Color.FromArgb( (int)( 255.0 * (0.5 * Math.Sin(theta) + 0.5 )), 64, 64 );
		}
	}
}
